import { jsx as c, jsxs as v, Fragment as R } from "react/jsx-runtime";
import i from "clsx";
import I, { useState as U, useEffect as z } from "react";
/*!
  @versini/ui-bubble v1.4.0
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_BUBBLE__ || (window.__VERSINI_UI_BUBBLE__ = {
    version: "1.4.0",
    buildTime: "12/26/2024 06:06 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const L = "av-bubble", S = "av-button";
/*!
  @versini/ui-spacing v1.1.0
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_SPACING__ || (window.__VERSINI_UI_SPACING__ = {
    version: "1.1.0",
    buildTime: "12/26/2024 06:05 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const $ = (e) => {
  let r = "";
  if (typeof e == "number" || typeof e == "string")
    r = "m-" + e;
  else {
    const t = [];
    (e == null ? void 0 : e.t) !== void 0 && t.push(`mt-${e.t}`), (e == null ? void 0 : e.r) !== void 0 && t.push(`mr-${e.r}`), (e == null ? void 0 : e.b) !== void 0 && t.push(`mb-${e.b}`), (e == null ? void 0 : e.l) !== void 0 && t.push(`ml-${e.l}`), r = t.join(" ");
  }
  return r;
}, N = "icon", P = "button", H = "link", j = ({
  type: e,
  size: r,
  labelRight: t,
  labelLeft: a,
  align: n
}) => {
  const o = "text-sm font-medium max-h-8 py-0", s = "text-base font-medium max-h-9 py-1", l = "text-lg font-medium max-h-12 py-2";
  switch (e) {
    case P:
      return i("px-4", {
        [o]: r === "small",
        [s]: r === "medium",
        [l]: r === "large"
      });
    case H:
      return i("px-4 text-center", {
        [o]: r === "small",
        [s]: r === "medium",
        [l]: r === "large"
      });
    case N:
      return i("inline-flex items-center", {
        "justify-center": n === "center",
        "justify-start": n === "left",
        "justify-end": n === "right",
        "h-6 w-6 p-0": r === "small" && !(t || a),
        "h-6 px-4 text-sm font-medium": r === "small" && (t || a),
        "h-8 w-8 p-1": r === "medium" && !(t || a),
        "h-8 px-4 text-base font-medium": r === "medium" && (t || a),
        "h-12 w-12 p-2": r === "large" && !(t || a),
        "h-12 px-4 text-lg font-medium": r === "large" && (t || a)
      });
  }
}, A = ({
  mode: e,
  noBackground: r,
  noTruncate: t,
  variant: a
}) => {
  if (r)
    return "not-prose rounded-full";
  if (a === "primary")
    return i("not-prose rounded-full", {
      truncate: !t,
      "bg-action-dark text-copy-light": e === "dark",
      "bg-action-light text-copy-lighter": e === "light",
      "bg-action-dark text-copy-light dark:bg-action-light dark:text-copy-lighter": e === "system",
      "bg-action-light text-copy-lighter dark:bg-action-dark dark:text-copy-light": e === "alt-system"
    });
  if (a === "secondary")
    return i("not-prose rounded-full", {
      truncate: !t,
      "bg-action-dark text-copy-light": e === "light",
      "bg-action-light text-copy-lighter": e === "dark",
      "bg-action-dark text-copy-light dark:bg-action-light dark:text-copy-lighter": e === "alt-system",
      "bg-action-light text-copy-lighter dark:bg-action-dark dark:text-copy-light": e === "system"
    });
  if (a === "danger")
    return i("not-prose rounded-full", {
      truncate: !t,
      "bg-action-danger-dark text-copy-light": e === "dark",
      "bg-action-danger-light text-copy-lighter": e === "light",
      "bg-action-danger-dark text-copy-light dark:bg-action-danger-light dark:text-copy-lighter": e === "system",
      "bg-action-danger-light text-copy-lighter dark:bg-action-danger-dark dark:text-copy-light": e === "alt-system"
    });
}, G = ({
  mode: e,
  disabled: r,
  variant: t
}) => {
  if (r)
    return "";
  if (t === "primary")
    return i("hover:text-copy-light-hover", {
      "hover:bg-action-dark-hover": e === "dark",
      "hover:bg-action-light-hover": e === "light",
      "hover:bg-action-dark-hover dark:hover:bg-action-light-hover": e === "system",
      "hover:bg-action-light-hover dark:hover:bg-action-dark-hover": e === "alt-system"
    });
  if (t === "secondary")
    return i("hover:text-copy-light-hover", {
      "hover:bg-action-dark-hover": e === "light",
      "hover:bg-action-light-hover": e === "dark",
      "hover:bg-action-dark-hover dark:hover:bg-action-light-hover": e === "alt-system",
      "hover:bg-action-light-hover dark:hover:bg-action-dark-hover": e === "system"
    });
  if (t === "danger")
    return i("hover:text-copy-light-hover", {
      "hover:bg-action-danger-dark-hover": e === "dark",
      "hover:bg-action-danger-light-hover": e === "light",
      "hover:bg-action-danger-dark-hover dark:hover:bg-action-danger-light-hover": e === "system",
      "hover:bg-action-danger-light-hover dark:hover:bg-action-danger-dark-hover": e === "alt-system"
    });
}, O = ({
  mode: e,
  disabled: r,
  variant: t
}) => {
  if (r)
    return "";
  if (t === "primary")
    return i("active:text-copy-light-active", {
      "active:bg-action-dark-active": e === "dark",
      "active:bg-action-light-active": e === "light",
      "active:bg-action-dark-active dark:active:bg-action-light-active": e === "system",
      "active:bg-action-light-active dark:active:bg-action-dark-active": e === "alt-system"
    });
  if (t === "secondary")
    return i("active:text-copy-light-active", {
      "active:bg-action-dark-active": e === "light",
      "active:bg-action-light-active": e === "dark",
      "active:bg-action-dark-active dark:active:bg-action-light-active": e === "alt-system",
      "active:bg-action-light-active dark:active:bg-action-dark-active": e === "system"
    });
  if (t === "danger")
    return i("active:text-copy-lighter-active", {
      "active:bg-action-danger-dark-active": e === "dark",
      "active:bg-action-danger-light-active": e === "light",
      "active:bg-action-danger-dark-active dark:active:bg-action-danger-light-active": e === "system",
      "active:bg-action-danger-light-active dark:active:bg-action-danger-dark-active": e === "alt-system"
    });
}, W = ({
  mode: e,
  noBorder: r,
  variant: t
}) => {
  if (r)
    return "border border-transparent";
  if (t === "primary")
    return i("border", {
      "border-border-dark": e === "dark",
      "border-border-accent": e === "light",
      "border-border-dark dark:border-border-accent": e === "system",
      "border-border-accent dark:border-border-dark": e === "alt-system"
    });
  if (t === "secondary")
    return i("border", {
      "border-border-dark": e === "light",
      "border-border-accent": e === "dark",
      "border-border-dark dark:border-border-accent": e === "alt-system",
      "border-border-accent dark:border-border-dark": e === "system"
    });
  if (t === "danger")
    return i("border", {
      "border-border-danger-dark": e === "dark",
      "border-border-danger-medium": e === "light",
      "border-border-danger-dark dark:border-border-danger-medium": e === "system",
      "border-border-danger-medium dark:border-border-danger-dark": e === "alt-system"
    });
}, q = ({ focusMode: e }) => i("focus:outline", "focus:outline-2", "focus:outline-offset-2", {
  "focus:outline-focus-dark": e === "dark",
  "focus:outline-focus-light": e === "light",
  "focus:outline-focus-light dark:focus:outline-focus-dark": e === "alt-system",
  "focus:outline-focus-dark dark:focus:outline-focus-light": e === "system"
}), T = ({
  type: e,
  className: r,
  raw: t,
  mode: a,
  focusMode: n,
  disabled: o,
  fullWidth: s,
  size: l,
  noBorder: b,
  labelRight: g,
  labelLeft: p,
  spacing: u,
  noBackground: m,
  variant: d,
  noTruncate: h,
  align: f
}) => (d || (d = "primary"), t ? i(S, r) : i(
  S,
  r,
  $(u),
  A({ mode: a, variant: d, noBackground: m, noTruncate: h }),
  j({ type: e, size: l, labelRight: g, labelLeft: p, align: f }),
  W({ mode: a, variant: d, noBorder: b }),
  q({ focusMode: n }),
  G({ mode: a, variant: d, disabled: o }),
  O({ mode: a, variant: d, disabled: o }),
  {
    "w-full": s,
    "disabled:cursor-not-allowed disabled:opacity-50": o
  }
)), D = (e, r, t) => {
  var a;
  !r && (!document.activeElement || document.activeElement !== e.currentTarget) && typeof ((a = e == null ? void 0 : e.currentTarget) == null ? void 0 : a.focus) == "function" && e.currentTarget.focus(), typeof t == "function" && t(e);
}, B = I.forwardRef((e, r) => {
  const { onClick: t, noInternalClick: a = !1, ...n } = e;
  return /* @__PURE__ */ c(
    "button",
    {
      ref: r,
      onClick: (o) => {
        D(o, a, t);
      },
      ...n
    }
  );
});
B.displayName = "BaseButton";
const C = I.forwardRef(
  ({
    children: e,
    disabled: r = !1,
    mode: t = "system",
    focusMode: a = "system",
    fullWidth: n = !1,
    className: o,
    type: s = "button",
    raw: l = !1,
    noBorder: b = !1,
    "aria-label": g,
    label: p,
    size: u = "medium",
    labelRight: m,
    labelLeft: d,
    spacing: h,
    noBackground: f = !1,
    align: y = "center",
    ...k
  }, x) => {
    const _ = T({
      type: N,
      mode: t,
      focusMode: a,
      fullWidth: n,
      disabled: r,
      raw: l,
      className: o,
      noBorder: b,
      size: u,
      labelRight: m,
      labelLeft: d,
      spacing: h,
      noBackground: f,
      align: y
    }), w = i({
      "text-copy-accent-dark": t === "light" && !l,
      "text-copy-light": t === "dark" && !l,
      "text-copy-accent-dark dark:text-copy-light": t === "alt-system" && !l,
      "text-copy-light dark:text-copy-accent-dark": t === "system" && !l
    });
    return /* @__PURE__ */ v(
      B,
      {
        ref: x,
        className: _,
        disabled: r,
        type: s,
        "aria-label": g || p,
        ...k,
        children: [
          d && /* @__PURE__ */ c("span", { className: "pr-2", children: d }),
          /* @__PURE__ */ c("div", { className: w, children: e }),
          m && /* @__PURE__ */ c("span", { className: "pl-2", children: m })
        ]
      }
    );
  }
);
C.displayName = "ButtonIcon";
/*!
  @versini/ui-button v1.6.0
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_BUTTON__ || (window.__VERSINI_UI_BUTTON__ = {
    version: "1.6.0",
    buildTime: "12/26/2024 06:05 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const F = I.forwardRef(
  ({
    children: e,
    disabled: r = !1,
    mode: t = "system",
    focusMode: a = "system",
    fullWidth: n = !1,
    className: o,
    type: s = "button",
    raw: l = !1,
    noBorder: b = !1,
    "aria-label": g,
    label: p,
    size: u = "medium",
    labelRight: m,
    labelLeft: d,
    spacing: h,
    noBackground: f = !1,
    align: y = "center",
    active: k = !1,
    ...x
  }, _) => {
    const w = T({
      type: N,
      mode: t,
      focusMode: a,
      fullWidth: n,
      disabled: r,
      raw: l,
      className: o,
      noBorder: b,
      size: u,
      labelRight: m,
      labelLeft: d,
      spacing: h,
      noBackground: f,
      align: y
    }), M = i({
      "text-copy-accent-dark": t === "light" && !l,
      "text-copy-light": t === "dark" && !l,
      "text-copy-accent-dark dark:text-copy-light": t === "alt-system" && !l,
      "text-copy-light dark:text-copy-accent-dark": t === "system" && !l
    }), V = k ? i(
      "relative",
      "focus-within:static",
      "focus-within:after:border-transparent",
      "after:absolute",
      "after:content-['']",
      "after:border-b-2",
      "after:bottom-[-4px]",
      "after:left-0",
      "after:right-0",
      {
        "after:border-table-dark": t === "dark",
        "after:border-table-light": t === "light",
        "after:border-table-dark dark:after:border-table-light": t === "system",
        "after:border-table-light dark:after:border-table-dark": t === "alt-system"
      }
    ) : "";
    return /* @__PURE__ */ c("div", { className: V, children: /* @__PURE__ */ v(
      B,
      {
        ref: _,
        className: w,
        disabled: r,
        type: s,
        "aria-label": g || p,
        ...x,
        children: [
          d && /* @__PURE__ */ c("span", { className: "pr-2", children: d }),
          /* @__PURE__ */ c("div", { className: M, children: e }),
          m && /* @__PURE__ */ c("span", { className: "pl-2", children: m })
        ]
      }
    ) });
  }
);
F.displayName = "ButtonSort";
/*!
  @versini/ui-spacing v1.1.0
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_SPACING__ || (window.__VERSINI_UI_SPACING__ = {
    version: "1.1.0",
    buildTime: "12/26/2024 06:05 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const J = (e) => {
  let r = "";
  if (typeof e == "number" || typeof e == "string")
    r = "m-" + e;
  else {
    const t = [];
    (e == null ? void 0 : e.t) !== void 0 && t.push(`mt-${e.t}`), (e == null ? void 0 : e.r) !== void 0 && t.push(`mr-${e.r}`), (e == null ? void 0 : e.b) !== void 0 && t.push(`mb-${e.b}`), (e == null ? void 0 : e.l) !== void 0 && t.push(`ml-${e.l}`), r = t.join(" ");
  }
  return r;
}, E = ({
  children: e,
  fill: r,
  viewBox: t,
  className: a,
  defaultViewBox: n,
  defaultClassName: o,
  spacing: s,
  title: l,
  semantic: b = !1,
  ...g
}) => {
  const p = J(s), u = i(
    p,
    a || o
  );
  return /* @__PURE__ */ v(R, { children: [
    /* @__PURE__ */ c(
      "svg",
      {
        xmlns: "http://www.w3.org/2000/svg",
        className: u,
        viewBox: t || n,
        fill: r || "currentColor",
        role: "img",
        "aria-hidden": !b,
        focusable: !1,
        ...g,
        children: e
      }
    ),
    l && b && /* @__PURE__ */ c("span", { className: "sr-only", children: l })
  ] });
};
/*!
  @versini/ui-svgicon v1.1.0
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_SVGICON__ || (window.__VERSINI_UI_SVGICON__ = {
    version: "1.1.0",
    buildTime: "12/26/2024 06:05 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const K = ({
  className: e,
  viewBox: r,
  spacing: t,
  title: a,
  monotone: n,
  ...o
}) => /* @__PURE__ */ v(
  E,
  {
    defaultViewBox: "0 0 448 512",
    defaultClassName: "size-5",
    viewBox: r,
    className: e,
    spacing: t,
    title: a || "Copied",
    ...o,
    children: [
      /* @__PURE__ */ c(
        "path",
        {
          opacity: "0.4",
          d: "M64 32C28.7 32 0 60.7 0 96V416c0 35.3 28.7 64 64 64H384c35.3 0 64-28.7 64-64V96c0-35.3-28.7-64-64-64H64zM337 209L209 337c-9.4 9.4-24.6 9.4-33.9 0l-64-64c-9.4-9.4-9.4-24.6 0-33.9s24.6-9.4 33.9 0l47 47L303 175c9.4-9.4 24.6-9.4 33.9 0s9.4 24.6 0 33.9z"
        }
      ),
      /* @__PURE__ */ c("path", { d: "M337 175c9.4 9.4 9.4 24.6 0 33.9L209 337c-9.4 9.4-24.6 9.4-33.9 0l-64-64c-9.4-9.4-9.4-24.6 0-33.9s24.6-9.4 33.9 0l47 47L303 175c9.4-9.4 24.6-9.4 33.9 0z" })
    ]
  }
), Q = ({
  className: e,
  viewBox: r,
  spacing: t,
  title: a,
  monotone: n,
  ...o
}) => /* @__PURE__ */ c(
  E,
  {
    defaultViewBox: "0 0 512 512",
    defaultClassName: "size-5",
    viewBox: r,
    className: e,
    spacing: t,
    title: a || "Copy",
    ...o,
    children: /* @__PURE__ */ c("path", { d: "M64 464H288c8.8 0 16-7.2 16-16V384h48v64c0 35.3-28.7 64-64 64H64c-35.3 0-64-28.7-64-64V224c0-35.3 28.7-64 64-64h64v48H64c-8.8 0-16 7.2-16 16V448c0 8.8 7.2 16 16 16zM224 304H448c8.8 0 16-7.2 16-16V64c0-8.8-7.2-16-16-16H224c-8.8 0-16 7.2-16 16V288c0 8.8 7.2 16 16 16zm-64-16V64c0-35.3 28.7-64 64-64H448c35.3 0 64 28.7 64 64V288c0 35.3-28.7 64-64 64H224c-35.3 0-64-28.7-64-64z" })
  }
);
/*!
  @versini/ui-icons v1.19.0
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_ICONS__ || (window.__VERSINI_UI_ICONS__ = {
    version: "1.19.0",
    buildTime: "12/26/2024 06:05 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
/*!
  @versini/ui-spacing v1.1.0
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_SPACING__ || (window.__VERSINI_UI_SPACING__ = {
    version: "1.1.0",
    buildTime: "12/26/2024 06:05 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const X = (e) => {
  let r = "";
  if (typeof e == "number" || typeof e == "string")
    r = "m-" + e;
  else {
    const t = [];
    (e == null ? void 0 : e.t) !== void 0 && t.push(`mt-${e.t}`), (e == null ? void 0 : e.r) !== void 0 && t.push(`mr-${e.r}`), (e == null ? void 0 : e.b) !== void 0 && t.push(`mb-${e.b}`), (e == null ? void 0 : e.l) !== void 0 && t.push(`ml-${e.l}`), r = t.join(" ");
  }
  return r;
}, Y = () => "p-4 sm:max-w-md md:max-w-2xl", Z = ({ kind: e }) => i({
  "bg-surface-lighter dark:bg-surface-dark": e === "left",
  "bg-surface-accent": e === "right"
}), ee = ({ kind: e }) => i(
  "prose prose-dark dark:prose-lighter prose-p:my-3 prose-blockquote:my-3 prose-ol:my-3 prose-ul:my-3 prose-ul:prose-li:marker:text-black",
  {
    "text-copy-lighter": e === "right"
  }
), te = ({ kind: e }) => i("rounded-b-xl", {
  "rounded-tr-xl": e === "left",
  "rounded-tl-xl": e === "right"
}), re = ({
  kind: e,
  className: r,
  spacing: t
}) => {
  const a = i(
    r,
    L,
    "flex items-start",
    X(t),
    {
      "flex-row-reverse": e === "right"
    }
  ), n = i(
    "flex flex-col empty:hidden",
    Y(),
    ee({ kind: e }),
    Z({ kind: e }),
    te({ kind: e })
  ), o = "pr-2 pt-1 text-end text-xs text-copy-light", s = i("flex flex-col-reverse gap-2 sm:flex-row", {
    "ml-2": e === "left",
    "mr-2": e === "right"
  });
  return {
    wrapper: a,
    main: n,
    footer: o,
    copyButton: s
  };
}, le = ({
  children: e,
  kind: r = "left",
  className: t,
  footer: a,
  rawFooter: n,
  copyToClipboard: o,
  copyToClipboardFocusMode: s = "system",
  copyToClipboardMode: l = "system",
  spacing: b
}) => {
  const [g, p] = U(!1), u = re({ kind: r, className: t, spacing: b }), m = !!o && (typeof o == "function" || typeof o == "string" || typeof e == "string"), d = () => {
    p(!0), typeof o == "function" ? o(e) : typeof o == "string" ? navigator.clipboard.writeText(o) : typeof e == "string" && navigator.clipboard.writeText(e);
  };
  return z(() => {
    let h;
    return g && (h = window.setTimeout(() => {
      p(!1);
    }, 3e3)), () => {
      clearTimeout(h);
    };
  }, [g]), /* @__PURE__ */ v("div", { className: u.wrapper, children: [
    /* @__PURE__ */ v("div", { children: [
      /* @__PURE__ */ c("div", { className: u.main, children: e }),
      a && Object.keys(a).map((h) => a[h] ? /* @__PURE__ */ c("div", { className: "prose-p:m-0", children: /* @__PURE__ */ v("p", { className: u.footer, children: [
        h,
        ": ",
        a[h]
      ] }) }, `-${h}`) : null),
      n && n
    ] }),
    m && /* @__PURE__ */ c("div", { className: u.copyButton, children: /* @__PURE__ */ c(
      C,
      {
        noBorder: !0,
        noBackground: !0,
        size: "small",
        mode: l,
        focusMode: s,
        label: g ? "Copied to clipboard" : "Copy to clipboard",
        onClick: d,
        disabled: g,
        children: g ? /* @__PURE__ */ c(K, { className: "size-3" }) : /* @__PURE__ */ c(Q, { className: "size-3" })
      }
    ) })
  ] });
};
export {
  L as BUBBLE_CLASSNAME,
  le as Bubble
};
